# Communication Plan

# Introduction

The purpose of this communication plan is to define the communication methods and channels used for the [**PROJECT NAME**]. Clear and consistent communication ensures good information flow as well as helps to achieve project's quality objectives.

# Stakeholders

## Project Stakeholders can be divided into four groups from the point of view of communication:
1. Project group team members [**NAMES HERE**]
2. Project manager(s) and Coaches [**NAME(S) HERE**]
3. Stakeholder representatives [**NAMES HERE**]
4. Other external stakeholders (e.g. Head of Department(s), technical experts, etc.)

This plan provides the basis for communication between the project team and three other project stakeholders.

## General Communications Channels

[**PROJECT NAME**] is using various forms of written and verbal communication: [**USED COMMUNICATION CHANNELS HERE**] (telephone, bulletin / white board, email, LN databases, internal mail..)

## Written Communication Models

Project-related written communications use the document templates as described in the book 'Yrityksen viestintä' (Corporate Communications, Kortetniemi, 1997) / JAMK Jyväskylä University of Applied Sciences reporting guidelines / something else (what?). Digital document storage format is further defined in a specific documentation plan.

## Internal Communications

Internal communications refer to communication within and inside the project group. Its goal is to convey project-related information to all members of the group, thereby supporting group collaboration and contributes to the formation of group identity. In addition, internal communication is the basis for all external communications.
Internal project communication uses both formal and informal channels. The project team meets weekly [**WHEN, WHAT DAY?**] to plan tasks of the coming week and to go through the events of the previous week. **The project manager prepares the weekly agenda and writes on the basis of the meeting a weekly plan that is set in the LN database and bulletin board.** An assigned secretary writes a note of all significant upcoming events and also informs members of the group about those by email.
In addition, the following aids are used to support both internal and external communications:

- [**LN APPLICATION HERE**], which includes information about contacts outside of main documentation with different stakeholders (i.e. phone call with the client).
- [**APPLICATION NAME HERE**], which allows distributing emails received in [**LN APPLICATION HERE**] to personal e-mail addresses of project group members.

## Communications with Coaches

Good and open communication between the team and the coaches is the key to allow coaches to have clear and complete view of the project, and thereby provide the team with sufficient resources to support the project and its progress. The most important communication channel will be [**LN DOCUMENT DATABASE HERE**] and [**WEEKLY, WHAT DAY**] coach meetings with [**COACH NAME HERE**]. Assigned project secretary prepares agendas for those meetings and writes notes about them. In addition to the above-mentioned communication channels, the most important channel of communication is [**EMAIL? SOMETHING ELSE?**], other ways are used where possible and necessary. All significant events related to the project will be reported to coaches on at least one of the above mentioned channels.

# Communications with Stakeholder Representatives

[**MEETINGS, MEETUPS?**] play a key role in the communication between the project team and the stakeholder representatives. Regular executive team meetings and their agendas are prepared by the project manager. In addition to the above, the primary communication channel is [**WHAT, EMAIL?**] and secondary [**WHAT, TELEPHONE?**]. For all project documents, assigned project secretary will send copies to the stakeholder representatives by email. [**NAME HERE**] is responsible for current affairs on behalf of the stakeholder, and [**NAME HERE**] for project management.

# Communications with External Stakeholders

Project team's own judgement is used with communicating with external stakeholders. Some of the external stakeholders (other projects, part of the department's staff..) have the opportunity to communicate via [**LN DISCUSSION DATABASE HERE**]. In addition, external stakeholders are provided information on the project's website.


# Monitoring and Evaluation of Communications

The success of the communications are continuously evaluated during the project, especially during weekly coach meetings and as well as in communication studies. Any inconvenience will be addressed immediately and the communication plan modified if and / or necessary.


# Sources

Original can be found here: [http://homes.jamk.fi/~huojo/opetus/IIZP2010/](http://homes.jamk.fi/~huojo/opetus/IIZP2010/)
